#include "dht11.h"
#include <delay.h>


unsigned char read_dht_hum()
{
unsigned char i,j;
//unsigned char timers;
//unsigned char time;
  #asm("cli")
//  timers=TIMSK;
//  time=TCNT2;
//  TIMSK=0x40; //   2
//  #asm("sei")
//=============MCU send START
  DHT_DDR|=(1<<DHT_BIT); //pin as output
  DHT_PORT&=~(1<<DHT_BIT); //0
  delay_ms(18);
  DHT_PORT|=(1<<DHT_BIT); //1
  DHT_DDR&=~(1<<DHT_BIT); //pin as input
//=============check DHT11 response
  delay_us(50);
  if (DHT_PIN&(1<<DHT_BIT))
    return 0;
  delay_us(80);
  if (!(DHT_PIN&(1<<DHT_BIT)))
    return 0;
//===============receive 40 data bits
  while (DHT_PIN&(1<<DHT_BIT));
  for (j=0; j<5; j++)
    {
    data[j]=0;
    for(i=0; i<8; i++)
        {
        while (!(DHT_PIN&(1<<DHT_BIT)));
        delay_us (30);
        if (DHT_PIN&(1<<DHT_BIT)) 
            data[j]|=1<<(7-i);
        while (DHT_PIN&(1<<DHT_BIT));
        }
    }
//  #asm("cli")
//  TIMSK=timers; //  
//  TCNT2=time;
  #asm("sei")
  if ((unsigned char)(data[0]+data[1]+data[2]+data[3])!=data[4]) //    CRC
  return 0;
  return 1; // data[0]-,  data[2]-
}